"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  INFINITE_KEY_PREFIX: () => INFINITE_KEY_PREFIX,
  INFINITE_PREFIX: () => INFINITE_PREFIX,
  KEY_PREFIX: () => KEY_PREFIX,
  KEY_SEPARATOR: () => KEY_SEPARATOR,
  POSTGREST_FILTER_KEY_PREFIX: () => POSTGREST_FILTER_KEY_PREFIX,
  createKeyGetter: () => createKeyGetter,
  decode: () => decode,
  encode: () => encode,
  infiniteMiddleware: () => infiniteMiddleware,
  middleware: () => middleware,
  useDeleteItem: () => useDeleteItem,
  useDeleteMutation: () => useDeleteMutation,
  useInfiniteQuery: () => useInfiniteQuery,
  useInfiniteScrollQuery: () => useInfiniteScrollQuery,
  useInsertMutation: () => useInsertMutation,
  usePaginationQuery: () => usePaginationQuery,
  usePostgrestFilterCache: () => usePostgrestFilterCache,
  useQueriesForTableLoader: () => useQueriesForTableLoader,
  useQuery: () => useQuery,
  useSubscription: () => useSubscription,
  useSubscriptionQuery: () => useSubscriptionQuery,
  useUpdateMutation: () => useUpdateMutation,
  useUpsertItem: () => useUpsertItem,
  useUpsertMutation: () => useUpsertMutation
});
module.exports = __toCommonJS(src_exports);
__reExport(src_exports, require("@supabase-cache-helpers/postgrest-shared"), module.exports);
__reExport(src_exports, require("@supabase-cache-helpers/postgrest-filter"), module.exports);
__reExport(src_exports, require("@supabase-cache-helpers/postgrest-fetcher"), module.exports);

// src/cache/use-delete-item.ts
var import_postgrest_mutate = require("@supabase-cache-helpers/postgrest-mutate");
var import_swr3 = require("swr");

// src/lib/constants.ts
var KEY_PREFIX = "postgrest";
var POSTGREST_FILTER_KEY_PREFIX = "postgrest-filter";
var KEY_SEPARATOR = "$";
var INFINITE_PREFIX = "$inf$";
var INFINITE_KEY_PREFIX = "page";

// src/lib/create-key-getter.ts
var import_postgrest_shared = require("@supabase-cache-helpers/postgrest-shared");
var createKeyGetter = (query, pageSize) => {
  if (!query)
    return () => null;
  return (pageIndex, previousPageData) => {
    if (previousPageData && ((0, import_postgrest_shared.isPostgrestHasMorePaginationResponse)(previousPageData) && !previousPageData.data.length || (0, import_postgrest_shared.isPostgrestPaginationResponse)(previousPageData) && !previousPageData.length))
      return null;
    const cursor = pageIndex * pageSize;
    return query.range(cursor, cursor + pageSize - 1);
  };
};

// src/lib/decode.ts
var decode = (key) => {
  if (typeof key !== "string")
    return null;
  const isInfinite = key.startsWith(INFINITE_PREFIX);
  let parsedKey = key.replace(INFINITE_PREFIX, "");
  const isPostgrestKey = parsedKey.startsWith(`${KEY_PREFIX}${KEY_SEPARATOR}`);
  if (!isPostgrestKey) {
    return null;
  }
  parsedKey = parsedKey.replace(`${KEY_PREFIX}${KEY_SEPARATOR}`, "");
  const [
    pagePrefix,
    schema,
    table,
    queryKey,
    bodyKey,
    count,
    head,
    orderByKey
  ] = parsedKey.split(KEY_SEPARATOR);
  const params = new URLSearchParams(queryKey);
  const limit = params.get("limit");
  const offset = params.get("offset");
  const countValue = count.replace("count=", "");
  return {
    limit: limit ? Number(limit) : void 0,
    offset: offset ? Number(offset) : void 0,
    bodyKey,
    count: countValue === "null" ? null : countValue,
    isHead: head === "head=true",
    isInfinite,
    key,
    isInfiniteKey: pagePrefix === INFINITE_KEY_PREFIX,
    queryKey,
    schema,
    table,
    orderByKey
  };
};

// src/lib/encode.ts
var encode = (parser, isInfinite) => {
  var _a;
  return [
    KEY_PREFIX,
    isInfinite ? INFINITE_KEY_PREFIX : "null",
    parser.schema,
    parser.table,
    parser.queryKey,
    (_a = parser.bodyKey) != null ? _a : "null",
    `count=${parser.count}`,
    `head=${parser.isHead}`,
    parser.orderByKey
  ].join(KEY_SEPARATOR);
};

// src/lib/middleware.ts
var import_postgrest_filter = require("@supabase-cache-helpers/postgrest-filter");
var import_postgrest_shared2 = require("@supabase-cache-helpers/postgrest-shared");
var middleware = (useSWRNext) => {
  return (key, fetcher, config) => {
    if (!fetcher)
      throw new Error("No fetcher provided");
    if (key !== null && !(0, import_postgrest_shared2.isPostgrestBuilder)(key)) {
      throw new Error("Key is not a PostgrestBuilder");
    }
    return useSWRNext(
      key ? encode(new import_postgrest_filter.PostgrestParser(key), false) : null,
      () => fetcher(key),
      config
    );
  };
};
var infiniteMiddleware = (useSWRInfiniteNext) => {
  return (keyFn, fetcher, config) => {
    return useSWRInfiniteNext(
      (index, previousPageData) => {
        const query = keyFn(index, previousPageData);
        if (!query)
          return null;
        if (!(0, import_postgrest_shared2.isPostgrestBuilder)(query)) {
          throw new Error("Key is not a PostgrestBuilder");
        }
        return encode(new import_postgrest_filter.PostgrestParser(query), true);
      },
      typeof fetcher === "function" ? (query) => fetcher(query) : fetcher,
      config
    );
  };
};

// src/lib/use-postgrest-filter-cache.ts
var import_postgrest_filter2 = require("@supabase-cache-helpers/postgrest-filter");
var import_swr = require("swr");
var usePostgrestFilterCache = () => {
  const { cache } = (0, import_swr.useSWRConfig)();
  return (query, opts) => {
    const key = [
      POSTGREST_FILTER_KEY_PREFIX,
      query,
      opts ? (0, import_postgrest_filter2.encodeObject)(opts) : null
    ].filter(Boolean).join(KEY_SEPARATOR);
    const cacheData = cache.get(key);
    if (cacheData && cacheData.data instanceof import_postgrest_filter2.PostgrestFilter) {
      return cacheData.data;
    }
    const filter = import_postgrest_filter2.PostgrestFilter.fromQuery(query, opts);
    cache.set(key, { data: filter });
    return filter;
  };
};

// src/lib/use-queries-for-table-loader.ts
var import_swr2 = require("swr");
var useQueriesForTableLoader = (table) => {
  const { cache } = (0, import_swr2.useSWRConfig)();
  const getPostgrestFilter = usePostgrestFilterCache();
  return () => Array.from(cache.keys()).reduce((prev, curr) => {
    const decodedKey = decode(curr);
    if ((decodedKey == null ? void 0 : decodedKey.table) === table) {
      prev.push(getPostgrestFilter(decodedKey.queryKey).params);
    }
    return prev;
  }, []);
};

// src/lib/mutable-keys.ts
var getMutableKeys = (keys) => {
  return keys.filter((k) => {
    const decoded = decode(k);
    return decoded && (decoded.isInfinite || !decoded.isInfiniteKey);
  });
};

// src/cache/use-delete-item.ts
function useDeleteItem(opts) {
  const { mutate, cache } = (0, import_swr3.useSWRConfig)();
  const getPostgrestFilter = usePostgrestFilterCache();
  return (input) => __async(this, null, function* () {
    return yield (0, import_postgrest_mutate.deleteItem)(
      __spreadValues({
        input
      }, opts),
      {
        cacheKeys: getMutableKeys(Array.from(cache.keys())),
        getPostgrestFilter,
        mutate,
        decode
      }
    );
  });
}

// src/cache/use-upsert-item.ts
var import_postgrest_mutate2 = require("@supabase-cache-helpers/postgrest-mutate");
var import_swr4 = require("swr");
function useUpsertItem(opts) {
  const { mutate, cache } = (0, import_swr4.useSWRConfig)();
  const getPostgrestFilter = usePostgrestFilterCache();
  return (input) => __async(this, null, function* () {
    return yield (0, import_postgrest_mutate2.upsertItem)(
      __spreadValues({
        input
      }, opts),
      {
        cacheKeys: getMutableKeys(Array.from(cache.keys())),
        getPostgrestFilter,
        mutate,
        decode
      }
    );
  });
}

// src/mutate/use-delete-mutation.ts
var import_postgrest_fetcher = require("@supabase-cache-helpers/postgrest-fetcher");
var import_postgrest_shared3 = require("@supabase-cache-helpers/postgrest-shared");
var import_mutation = __toESM(require("swr/mutation"));

// src/mutate/use-random-key.ts
var import_react = require("react");
var PREFIX = "random-mutation-key";
var useRandomKey = () => {
  const key = (0, import_react.useId)();
  return [PREFIX, key].join(KEY_SEPARATOR);
};

// src/mutate/use-delete-mutation.ts
function useDeleteMutation(qb, primaryKeys, query, opts) {
  const key = useRandomKey();
  const queriesForTable = useQueriesForTableLoader((0, import_postgrest_shared3.getTable)(qb));
  const deleteItem2 = useDeleteItem({
    primaryKeys,
    table: (0, import_postgrest_shared3.getTable)(qb),
    schema: qb.schema,
    opts
  });
  return (0, import_mutation.default)(
    key,
    (_0, _1) => __async(this, [_0, _1], function* (_, { arg }) {
      var _a;
      const result = yield (0, import_postgrest_fetcher.buildDeleteFetcher)(qb, primaryKeys, {
        query: query != null ? query : void 0,
        queriesForTable,
        disabled: opts == null ? void 0 : opts.disableAutoQuery
      })(arg);
      if (result) {
        deleteItem2(result == null ? void 0 : result.normalizedData);
      }
      return (_a = result == null ? void 0 : result.userQueryData) != null ? _a : null;
    }),
    opts
  );
}

// src/mutate/use-insert-mutation.ts
var import_postgrest_fetcher2 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_postgrest_shared4 = require("@supabase-cache-helpers/postgrest-shared");
var import_mutation2 = __toESM(require("swr/mutation"));

// src/mutate/get-user-response.ts
function truthy(value) {
  return !!value;
}
var getUserResponse = (d) => {
  if (!d)
    return d;
  return d.map((r) => r.userQueryData).filter(truthy);
};

// src/mutate/use-insert-mutation.ts
function useInsertMutation(qb, primaryKeys, query, opts) {
  const key = useRandomKey();
  const queriesForTable = useQueriesForTableLoader((0, import_postgrest_shared4.getTable)(qb));
  const upsertItem2 = useUpsertItem({
    primaryKeys,
    table: (0, import_postgrest_shared4.getTable)(qb),
    schema: qb.schema,
    opts
  });
  return (0, import_mutation2.default)(
    key,
    (_0, _1) => __async(this, [_0, _1], function* (key2, { arg }) {
      const result = yield (0, import_postgrest_fetcher2.buildInsertFetcher)(qb, {
        query: query != null ? query : void 0,
        queriesForTable,
        disabled: opts == null ? void 0 : opts.disableAutoQuery
      })(arg);
      if (result) {
        Promise.all(
          (result != null ? result : []).map(
            (d) => __async(this, null, function* () {
              return yield upsertItem2(d.normalizedData);
            })
          )
        );
      }
      return getUserResponse(result);
    }),
    opts
  );
}

// src/mutate/use-update-mutation.ts
var import_postgrest_fetcher3 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_postgrest_shared5 = require("@supabase-cache-helpers/postgrest-shared");
var import_mutation3 = __toESM(require("swr/mutation"));
function useUpdateMutation(qb, primaryKeys, query, opts) {
  const key = useRandomKey();
  const queriesForTable = useQueriesForTableLoader((0, import_postgrest_shared5.getTable)(qb));
  const upsertItem2 = useUpsertItem({
    primaryKeys,
    table: (0, import_postgrest_shared5.getTable)(qb),
    schema: qb.schema,
    opts
  });
  return (0, import_mutation3.default)(
    key,
    (_0, _1) => __async(this, [_0, _1], function* (_, { arg }) {
      var _a;
      const result = yield (0, import_postgrest_fetcher3.buildUpdateFetcher)(qb, primaryKeys, {
        query: query != null ? query : void 0,
        queriesForTable,
        disabled: opts == null ? void 0 : opts.disableAutoQuery
      })(arg);
      if (result == null ? void 0 : result.normalizedData) {
        upsertItem2(result == null ? void 0 : result.normalizedData);
      }
      return (_a = result == null ? void 0 : result.userQueryData) != null ? _a : null;
    }),
    opts
  );
}

// src/mutate/use-upsert-mutation.ts
var import_postgrest_fetcher4 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_postgrest_shared6 = require("@supabase-cache-helpers/postgrest-shared");
var import_mutation4 = __toESM(require("swr/mutation"));
function useUpsertMutation(qb, primaryKeys, query, opts) {
  const key = useRandomKey();
  const queriesForTable = useQueriesForTableLoader((0, import_postgrest_shared6.getTable)(qb));
  const upsertItem2 = useUpsertItem({
    primaryKeys,
    table: (0, import_postgrest_shared6.getTable)(qb),
    schema: qb.schema,
    opts
  });
  return (0, import_mutation4.default)(
    key,
    (_0, _1) => __async(this, [_0, _1], function* (_, { arg }) {
      const result = yield (0, import_postgrest_fetcher4.buildUpsertFetcher)(qb, {
        query: query != null ? query : void 0,
        queriesForTable,
        disabled: opts == null ? void 0 : opts.disableAutoQuery
      })(arg);
      if (result) {
        Promise.all(
          result.map(
            (d) => __async(this, null, function* () {
              return yield upsertItem2(d.normalizedData);
            })
          )
        );
      }
      return getUserResponse(result);
    }),
    opts
  );
}

// src/query/use-infinite-query.ts
var import_postgrest_fetcher5 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_infinite = __toESM(require("swr/infinite"));
function useInfiniteQuery(query, config) {
  var _a, _b, _c;
  return (0, import_infinite.default)(
    createKeyGetter(query, (_a = config == null ? void 0 : config.pageSize) != null ? _a : 20),
    (0, import_postgrest_fetcher5.createPaginationFetcher)(
      query,
      (key) => {
        const decodedKey = decode(key);
        if (!decodedKey) {
          throw new Error("Not a SWRPostgrest key");
        }
        return {
          limit: decodedKey.limit,
          offset: decodedKey.offset
        };
      },
      (_b = config == null ? void 0 : config.pageSize) != null ? _b : 20
    ),
    __spreadProps(__spreadValues({}, config), {
      use: [
        ...(_c = config == null ? void 0 : config.use) != null ? _c : [],
        infiniteMiddleware
      ]
    })
  );
}

// src/query/use-infinite-scroll-query.ts
var import_postgrest_fetcher6 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_react2 = require("react");
var import_infinite2 = __toESM(require("swr/infinite"));
function useInfiniteScrollQuery(query, config) {
  var _a, _b, _c;
  const _d = (0, import_infinite2.default)(
    createKeyGetter(query, (_a = config == null ? void 0 : config.pageSize) != null ? _a : 20),
    (0, import_postgrest_fetcher6.createPaginationHasMoreFetcher)(
      query,
      (key) => {
        const decodedKey = decode(key);
        if (!decodedKey) {
          throw new Error("Not a SWRPostgrest key");
        }
        return {
          limit: decodedKey.limit,
          offset: decodedKey.offset
        };
      },
      (_b = config == null ? void 0 : config.pageSize) != null ? _b : 20
    ),
    __spreadProps(__spreadValues({}, config), {
      use: [
        ...(_c = config == null ? void 0 : config.use) != null ? _c : [],
        infiniteMiddleware
      ]
    })
  ), { data, setSize, size } = _d, rest = __objRest(_d, ["data", "setSize", "size"]);
  const { data: flatData, hasMore } = (0, import_react2.useMemo)(() => {
    return {
      data: (data != null ? data : []).flatMap((p) => p.data),
      hasMore: Array.isArray(data) && data.length > 0 && data[data.length - 1].hasMore
    };
  }, [data]);
  return __spreadValues({
    data: flatData,
    size,
    setSize,
    loadMore: hasMore ? () => setSize(size + 1) : null
  }, rest);
}

// src/query/use-pagination-query.ts
var import_postgrest_fetcher7 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_react3 = require("react");
var import_infinite3 = __toESM(require("swr/infinite"));
function usePaginationQuery(query, config) {
  var _a, _b, _c, _e;
  const _d = (0, import_infinite3.default)(
    createKeyGetter(query, (_a = config == null ? void 0 : config.pageSize) != null ? _a : 20),
    (0, import_postgrest_fetcher7.createPaginationHasMoreFetcher)(
      query,
      (key) => {
        const decodedKey = decode(key);
        if (!decodedKey) {
          throw new Error("Not a SWRPostgrest key");
        }
        return {
          limit: decodedKey.limit,
          offset: decodedKey.offset
        };
      },
      (_b = config == null ? void 0 : config.pageSize) != null ? _b : 20
    ),
    __spreadProps(__spreadValues({}, config), {
      use: [
        ...(_c = config == null ? void 0 : config.use) != null ? _c : [],
        infiniteMiddleware
      ]
    })
  ), { data, setSize, size } = _d, rest = __objRest(_d, ["data", "setSize", "size"]);
  const [currentPageIndex, setCurrentPageIndex] = (0, import_react3.useState)(0);
  const { data: parsedData, hasMore } = (0, import_react3.useMemo)(() => {
    return {
      data: (data != null ? data : []).map((p) => p.data),
      hasMore: Array.isArray(data) && data.length > 0 && data[data.length - 1].hasMore
    };
  }, [data]);
  return __spreadValues({
    pages: parsedData,
    currentPage: parsedData ? (_e = parsedData[currentPageIndex]) != null ? _e : [] : [],
    pageIndex: currentPageIndex,
    setPage: (idx) => setCurrentPageIndex(idx),
    nextPage: hasMore || currentPageIndex < size - 1 ? () => {
      if (currentPageIndex === size - 1) {
        setSize((size2) => size2 + 1);
      }
      setCurrentPageIndex((page) => page + 1);
    } : null,
    previousPage: currentPageIndex > 0 ? () => setCurrentPageIndex((current) => current - 1) : null
  }, rest);
}

// src/query/use-query.ts
var import_postgrest_shared7 = require("@supabase-cache-helpers/postgrest-shared");
var import_swr5 = __toESM(require("swr"));
function useQuery(query, config) {
  var _a, _c;
  const _b = (0, import_swr5.default)(
    query,
    (q) => __async(this, null, function* () {
      if ((0, import_postgrest_shared7.isPostgrestBuilder)(q)) {
        q = q.throwOnError();
      }
      return yield q;
    }),
    __spreadProps(__spreadValues({}, config), {
      use: [...(_a = config == null ? void 0 : config.use) != null ? _a : [], middleware]
    })
  ), { data } = _b, rest = __objRest(_b, ["data"]);
  return __spreadValues({ data: data == null ? void 0 : data.data, count: (_c = data == null ? void 0 : data.count) != null ? _c : null }, rest);
}

// src/subscribe/use-subscription-query.ts
var import_postgrest_fetcher8 = require("@supabase-cache-helpers/postgrest-fetcher");
var import_supabase_js = require("@supabase/supabase-js");
var import_react4 = require("react");
function useSubscriptionQuery(client, channelName, filter, primaryKeys, query, opts) {
  const [status, setStatus] = (0, import_react4.useState)();
  const [channel, setChannel] = (0, import_react4.useState)();
  const queriesForTable = useQueriesForTableLoader(filter.table);
  const deleteItem2 = useDeleteItem({
    primaryKeys,
    table: filter.table,
    schema: filter.schema,
    opts
  });
  const upsertItem2 = useUpsertItem({
    primaryKeys,
    table: filter.table,
    schema: filter.schema,
    opts
  });
  (0, import_react4.useEffect)(() => {
    if (!client)
      return;
    const c = client.channel(channelName).on(
      import_supabase_js.REALTIME_LISTEN_TYPES.POSTGRES_CHANGES,
      filter,
      (payload) => __async(this, null, function* () {
        var _a;
        let data = (_a = payload.new) != null ? _a : payload.old;
        const selectQuery = (0, import_postgrest_fetcher8.loadQuery)({ queriesForTable, query });
        if (payload.eventType !== import_supabase_js.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.DELETE && selectQuery) {
          const qb = client.from(payload.table).select(selectQuery.selectQuery);
          for (const pk of primaryKeys) {
            qb.eq(pk.toString(), data[pk]);
          }
          const res = yield qb.single();
          if (res.data)
            data = res.data;
        }
        if (payload.eventType === import_supabase_js.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.INSERT || payload.eventType === import_supabase_js.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.UPDATE) {
          yield upsertItem2(data);
        } else if (payload.eventType === import_supabase_js.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.DELETE) {
          yield deleteItem2(data);
        }
        if (opts == null ? void 0 : opts.callback) {
          opts.callback(__spreadProps(__spreadValues({}, payload), {
            data
          }));
        }
      })
    ).subscribe((status2) => setStatus(status2));
    setChannel(c);
    return () => {
      if (c)
        c.unsubscribe();
    };
  }, []);
  return { channel, status };
}

// src/subscribe/use-subscription.ts
var import_supabase_js2 = require("@supabase/supabase-js");
var import_react5 = require("react");
function useSubscription(channel, filter, primaryKeys, opts) {
  const [status, setStatus] = (0, import_react5.useState)();
  const deleteItem2 = useDeleteItem({
    primaryKeys,
    table: filter.table,
    schema: filter.schema,
    opts
  });
  const upsertItem2 = useUpsertItem({
    primaryKeys,
    table: filter.table,
    schema: filter.schema,
    opts
  });
  (0, import_react5.useEffect)(() => {
    if (!channel)
      return;
    const c = channel.on(
      import_supabase_js2.REALTIME_LISTEN_TYPES.POSTGRES_CHANGES,
      filter,
      (payload) => __async(this, null, function* () {
        if (payload.eventType === import_supabase_js2.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.INSERT || payload.eventType === import_supabase_js2.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.UPDATE) {
          yield upsertItem2(payload.new);
        } else if (payload.eventType === import_supabase_js2.REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.DELETE) {
          yield deleteItem2(payload.old);
        }
        if (opts == null ? void 0 : opts.callback) {
          opts.callback(__spreadValues({}, payload));
        }
      })
    ).subscribe((status2) => setStatus(status2));
    return () => {
      if (c)
        c.unsubscribe();
    };
  }, []);
  return { status };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  INFINITE_KEY_PREFIX,
  INFINITE_PREFIX,
  KEY_PREFIX,
  KEY_SEPARATOR,
  POSTGREST_FILTER_KEY_PREFIX,
  createKeyGetter,
  decode,
  encode,
  infiniteMiddleware,
  middleware,
  useDeleteItem,
  useDeleteMutation,
  useInfiniteQuery,
  useInfiniteScrollQuery,
  useInsertMutation,
  usePaginationQuery,
  usePostgrestFilterCache,
  useQueriesForTableLoader,
  useQuery,
  useSubscription,
  useSubscriptionQuery,
  useUpdateMutation,
  useUpsertItem,
  useUpsertMutation,
  ...require("@supabase-cache-helpers/postgrest-shared"),
  ...require("@supabase-cache-helpers/postgrest-filter"),
  ...require("@supabase-cache-helpers/postgrest-fetcher")
});
//# sourceMappingURL=index.js.map